import { storeHelper } from '@redux-model/core';
import local from '../storages/localStorage';
import session from '../storages/sessionStorage';
/**
 * The store engine for persist.
 *
 * `local:   Promised localStorage`
 *
 * `session: Promised sessionStorage`
 *
 * `memory:  Promised object for testing`
 */
export var createReduxStore = function (config) {
    if (config === void 0) { config = {}; }
    var persit = config.persist;
    if (persit) {
        switch (persit.storage) {
            case 'local':
                persit.storage = local;
                break;
            case 'session':
                persit.storage = session;
                break;
        }
    }
    return storeHelper.createStore(config);
};
