import * as Vue from 'vue';
import cloneDeep from 'clone';
import { applyPatch } from './diff';
import { storeHelper } from '@redux-model/core';
storeHelper.onCreated(function () {
    var getCurrentState = storeHelper.store.getState;
    var originalState = getCurrentState();
    var observer = Vue.reactive(cloneDeep(originalState));
    // Vue component will never visit state during dispatching.
    // So original state will respond by storeHelper.getState() during dispatching.
    storeHelper.getState = function () {
        return observer;
    };
    storeHelper.store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
