import * as Vue from 'vue';
import { AxiosRequestConfig } from 'axios';
import { BaseRequestAction, HttpServiceBuilder, Meta } from '@redux-model/core';
export declare class RequestAction<Data, Builder extends (...args: any[]) => HttpServiceBuilder<Data, Response, Payload, AxiosRequestConfig, M>, Response, Payload, M> extends BaseRequestAction<Data, Builder, Response, Payload, M> {
    useMeta(): Vue.ComputedRef<Meta>;
    useMeta<T extends keyof Meta>(key?: T): Vue.ComputedRef<Meta[T]>;
    useMetas(value: M): Vue.ComputedRef<Meta>;
    useMetas<T extends keyof Meta>(value: M, metaKey: T): Vue.ComputedRef<Meta[T]>;
    useLoading(): Vue.ComputedRef<boolean>;
    useLoadings(value: M): Vue.ComputedRef<boolean>;
    protected methods(): string[];
}
