"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var Vue = tslib_1.__importStar(require("vue"));
var clone_1 = tslib_1.__importDefault(require("clone"));
var diff_1 = require("./diff");
var core_1 = require("@redux-model/core");
core_1.storeHelper.onCreated(function () {
    var getCurrentState = core_1.storeHelper.store.getState;
    var originalState = getCurrentState();
    var observer = Vue.reactive(clone_1.default(originalState));
    // Vue component will never visit state during dispatching.
    // So original state will respond by storeHelper.getState() during dispatching.
    core_1.storeHelper.getState = function () {
        return observer;
    };
    core_1.storeHelper.store.subscribe(function () {
        var currentState = getCurrentState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, observer);
            originalState = currentState;
        }
    });
});
